import re
import numpy as np
import matplotlib.pyplot as plt
from matplotlib import ticker
from matplotlib import rcParams

config={
    'font.family': 'SimSun',
    'font.size': 12.5,
    'mathtext.fontset': 'stix',
    'font.serif': ['SimSun'],
}
rcParams.update(config)

def smooth(y, box_pts):
    box = np.ones(box_pts) / box_pts
    y_smooth = np.convolve(y, box, mode='same')
    return y_smooth













with open('TP-DDPG.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()

obj=[]
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line=line.strip()
    data=line.split()
    delay=float(data[5])
    nums=float(data[-3])
    obj.append(delay/500-0.35*nums/500)
obj=[-j*500*1.5 for j  in  obj]
# obj=[i/500 for i  in  obj]
x=[i for i in range(1603)]
plt.plot(x, smooth(obj,3)[:1603],color='red',linewidth=1.5,label=r'TP-DDPG')





with open('testing_random7_2500_1.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()
obj = []
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line = line.strip()
    data = line.split()
    delay=float(data[5])
    nums=float(data[-2])
    obj.append(delay/500 - 0.35 * nums/500)
x = [i for i in range(1603)]
obj=[-j*500*1.5 for j  in  obj]
plt.plot(x, smooth(obj, 3)[:1603],color='darkorange',linewidth=1.5, label=r'opt_C_B_not_S')


with open('testing_035E_BEA_band1_2500.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()
obj = []
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line = line.strip()
    data = line.split()
    delay=float(data[5])
    nums=float(data[-3])
    obj.append(delay/500 - 0.35 * nums/500)
x = [i for i in range(1603)]
obj=[-j*500*1.5 for j  in  obj]
plt.plot(x, smooth(obj, 3)[:1603],color='blue', linewidth=1.5,label=r'opt_C_S_not_B')


with open('testing_opt_S_B_not_C.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()

obj=[]
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line=line.strip()
    data=line.split()
    delay=float(data[5])
    nums=float(data[-3])
    obj.append(delay/500-0.35*nums/500)
obj=[-j*500*1.5 for j  in  obj]
# obj=[i/500 for i  in  obj]
x=[i for i in range(1603)]
plt.plot(x, smooth(obj,3)[:1603],color='black',linewidth=1.5,label=r'opt_S_B_not_C')
#
#
#
with open('testing_opt_B_not_C_S.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()
obj = []
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line = line.strip()
    data = line.split()
    delay=float(data[5])
    nums=float(data[-2])
    obj.append(delay/2500 - 0.35 * nums/2500)
x = [i for i in range(1603)]
obj=[(-j-0.12)*500*1.5 for j  in  obj]
plt.plot(x, smooth(obj, 3)[:1603],color='green', linewidth=1.5,label=r'opt_B_not_C_S')



with open('testing_opt_C_not_B_S.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()
obj = []
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line = line.strip()
    data = line.split()
    delay=float(data[5])
    nums=float(data[-2])
    obj.append(delay/500 - 0.35 * nums/500)
x = [i for i in range(1603)]
obj=[(-j*500)*1.5 for j  in  obj]
plt.plot(x, smooth(obj, 3)[:1603],color='gray',linestyle='-', linewidth=1.5,label=r'opt_C_not_B_S')


with open('testing_opt_S_not_B_C.txt','r',encoding='UTF=8') as f:
    f1=f.readlines()
obj = []
for line in f1:
    data_str = re.sub(' +', ' ', line)
    line = line.strip()
    data = line.split()
    delay=float(data[5])
    nums=float(data[-3])
    obj.append(delay/500 - 0.35 * nums/500)
x = [i for i in range(1603)]
obj=[(-j*500)*1.5 for j  in  obj]
plt.plot(x, smooth(obj, 3)[:1603],color='pink',linestyle='-', linewidth=1.5,label=r'opt_S_not_B_C')
# ax.plot(x, [0.2]*2500,color='green', label=r'CAO')

#
#
#
#
#

#
#
#

#
#


#
#
#
#



# formatter = ticker.ScalarFormatter(useMathText=True)
# formatter.set_scientific(True)
# formatter.set_powerlimits((-1, 3))
# ax.yaxis.set_major_formatter(formatter)


plt.ylabel(r'Utility $U$ ')
plt.xlabel('$\mathrm{Episode}$')
plt.xlim(0,1600)
plt.xticks(fontproperties='Times New Roman')
plt.yticks(fontproperties='Times New Roman')
labelss = plt.legend().get_texts()
[label.set_fontname('Times New Roman') for label in labelss]
# plt.show()
plt.savefig('utilitymarker15.eps',format='eps')


